﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Text;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_Authentication : System.Web.UI.Page
{
    protected string mAuthName = "";
    protected string mAuthUser = "";
    protected string mAuthTel = "";
    protected string mAuthEmail = "";
    protected string mAuthKey = "";
    protected string mAuthPublic = "";
    protected string mAuthMsg = "";
    protected string mProductVersion = "";
    protected int mUserCount = 0;
    protected string strDemo = ConfigurationSettings.AppSettings["strDemo"];
    
    private JavaScript JS;
    private AuthKey ak = null;
    
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";

    protected string strYear = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/Login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            JS.MessageBox("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Mail/Main.aspx");
        }

        ak = new AuthKey();

        strYear = DateTime.Now.Year.ToString();

        if (!Page.IsPostBack)
        {
            if (File.Exists(Passkorea.Configuration.GetMailRoot + "\\AuthKeyInfo.dat"))
            {
                tblFormAuthKey.Visible = false;
                tblShowAuthInfo.Visible = true;
                this.CheckAuthKey();
            }
            else
            {
                tblFormAuthKey.Visible = true;
                tblShowAuthInfo.Visible = false;
            }

            try
            {
                AppVersion appVer = new AppVersion();

                if (appVer.GetVersion())
                    spnVersion.InnerText = appVer.MajorVersion + "." + appVer.MinorVersion + "." + appVer.MaintenanceVersion;// +"." + appVer.BetaVersion;
            }
            catch
            {
                spnVersion.InnerText = "5.0.1";
            }
        }

        ibAuthBtn.Attributes.Add("onclick", "if (!AddAuthKey()) return false; else return true;");
        
        Page.DataBind();
    }

    private void CheckAuthKey()
    {
        if (!ak.AuthenticationKey())
        {
            JS.MessageBox(ak.ErrorMessage);
            return;
        }

        mAuthName = ak.Company;
        mAuthUser = ak.AuthUser;
        mAuthTel = ak.AuthTel;
        mAuthEmail = ak.AuthEmail;
        mAuthKey = ak.Key;
        mAuthPublic = ak.Public;
        mAuthMsg = ak.ErrorMessage;
        mProductVersion = ak.ProductVersion;

        if (mAuthKey.Trim() == "")
        {
            JS.MessageBox("인증키가 등록되지 않았습니다.");
            return;
        }

        if (!Passkorea.Configuration.CheckAuthKey(mAuthKey))
        {
            JS.MessageBox("잘못된 인증키 입니다.\r\n인증키가 잘못되면 메일 발송시에 Nmail 광고 문구가 붙어서 발송됩니다.");
            return;
        }
        mUserCount = Passkorea.Configuration.UserCount;
    }

    #region 인증키 등록
    /// <summary>
    /// 인증키 등록
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAuthBtn_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strAuthName = tbAuthName.Text;
        string strAuthUser = tbAuthUser.Text;
        string strAuthTel = tbAuthTel.Text;
        string strAuthEMail = tbAuthEmail.Text;
        string strAuthKey = tbAuthKey1.Text + "-" + tbAuthKey2.Text + "-" + tbAuthKey3.Text + "-" + tbAuthKey4.Text;
        bool bStatus = false;

        bStatus = ak.RegistryAuthKey(strAuthName, strAuthUser, strAuthTel, strAuthEMail, strAuthKey);

        if (!bStatus)
        {
            JS.MessageBox(ak.ErrorMessage);
            return;
        }

        JS.MessageBox("인증키가 등록되었습니다.");
        JS.MovePage("Authentication.aspx");
        return;
    }
    #endregion
}
