﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class AdminMenu_DomainConfig_ModifyDomain : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter sParams = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataTable dt = new DataTable();
    private DataSet ds = new DataSet();
    private JavaScript JS;

    private string strDemo = ConfigurationSettings.AppSettings["strDemo"];
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strDomain = "";
    protected string strMfDomain = "";
    protected string strUseSize = "";
    protected string strUserCount = "";
    protected string UserDefaultSize = "";
    protected string DownLimitDay = "";
    protected string DownLimitCount ="";
    protected string BigFileDefaultSize = "";
    protected string BigFileDownLimitDay = "";
    protected string BigFileDownLimitCount = "";
    protected string strWebUploadPath = "";
    protected string strImage = "";
    protected string strExt = "";
    protected string strLogoImage = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../../Log/Login.aspx", false);

        strMfDomain = Request.Params["dm"];

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UserInfo UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);

        if (UI.UserPermit != "1")
        {
            JS.MessageBox("여기는 웹메일 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../../Mail/Main.aspx");
            return;
        }

        if (Passkorea.Configuration.GetConfigField("serverinfo", "root_domain") != strDomain)
        {
            JS.MessageBox("여기는 전체 관리자만 접근할 수 있는 페이지 입니다.");
            Response.Redirect("../Default.aspx");
            return;
        }

        strWebUploadPath = Server.MapPath("../../") + "\\images\\Logo\\";

        if (!Page.IsPostBack)
        {
            DomainDataBind();
        }

        if (strDemo.ToLower() == "yes")
            btnModifyDomain.Attributes.Add("onclick", "alert(\"데모라서 수정할 수 없습니다.\"); return false;");
    }

    private void DomainDataBind()
    {
        int i = 0;

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" + err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prLoadDomain";

            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strMfDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strDomain"].Value = strMfDomain;

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "Nm_Domain");
            dt = ds.Tables["Nm_Domain"];

            if (dt.Rows.Count > 0)
            {
                string strJoinType = "";
                string strPop3Allow = "";
                string strUseGroup = "";

                DataRow dr = dt.Rows[0];
                tbDomain.ReadOnly = true;
                tbDomain.Text = strMfDomain;
                tbAllocateSize.Text = dr["Ndl_Allow_Size"].ToString();
                tbUserCount.Text = dr["Ndl_User_Count"].ToString();
                tbDefaultSize.Text = dr["Ndl_Default_Size"].ToString();
                tbCopyright.Text = dr["Ndl_Copyright"].ToString();

                strUserCount = dr["User_Count"].ToString();
                strUseSize = dr["Ndl_Use_Size"].ToString();

                strJoinType = dr["Ndl_Smtp_Allow"].ToString().ToUpper(); 
                strPop3Allow = dr["Ndl_Pop3_Allow"].ToString().ToUpper();
                strUseGroup = dr["Ndl_Use_Group"].ToString();

                //2010.12.27 imap4추가
                string strImap4Allow = dr["NDL_IMAP4_ALLOW"].ToString().ToUpper();

                //2011.08.25 웹사이트명,회사,도메인관리자 연락처,메일주소,ssl,회원가입버튼 노출여부 추가
                tbWebName.Text = dr["NDL_WEBNAME"].ToString();
                tbCompany.Text = dr["NDL_COMPANY"].ToString();
                tbTel.Text = dr["NDL_TEL"].ToString();
                tbmail.Text = dr["NDL_EMAIL"].ToString();
                string strJoin = dr["NDL_JOIN"].ToString();
                string strSsl = dr["NDL_SSL"].ToString();
                string strDoc = dr["NDL_DOC"].ToString();
                string strFileName = dr["NDL_FILE_NAME"].ToString();

                #region 2011.08.25 소스 간략화
                /// <summary>
                /// 2011.08.25 소스 간략화
                /// </summary>

                /*
                for (i = 0; i < rblJoinType.Items.Count; i++)
                {
                    if (rblJoinType.Items[i].Value == strJoinType)
                    {
                        rblJoinType.Items[i].Selected = true;
                        break;
                    }
                }

                for (i = 0; i < rblPop3Allow.Items.Count; i++)
                {
                    if (rblPop3Allow.Items[i].Value == strPop3Allow)
                    {
                        rblPop3Allow.Items[i].Selected = true;
                        break;
                    }
                }

                for (i = 0; i < rblUseGroup.Items.Count; i++)
                {
                    if (rblUseGroup.Items[i].Value == strUseGroup)
                    {
                        rblUseGroup.Items[i].Selected = true;
                        break;
                    }
                }

                //2010.12.27 imap4 추가
                for (i = 0; i < rblImap4Allow.Items.Count; i++)
                {
                    if (rblImap4Allow.Items[i].Value == strImap4Allow)
                    {
                        rblImap4Allow.Items[i].Selected = true;
                        break;
                    }
                }
                 */
                #endregion

                //2011.08.25 App_Code에 Common.cs 추가 라디오버튼에 내용 넣는 로직 변경
                Common.SetRadioButtonList(rblJoinType, strJoinType);
                Common.SetRadioButtonList(rblPop3Allow, strPop3Allow);
                Common.SetRadioButtonList(rblUseGroup, strUseGroup);
                Common.SetRadioButtonList(rblImap4Allow, strImap4Allow);

                //2011.08.25 ssl,회원가입버튼 노출여부 추가
                Common.SetRadioButtonList(rbJoin, strJoin);
                Common.SetRadioButtonList(rbSsl, strSsl);

                //2012.01.10 비밀번호 강화 기능 추가
                Common.SetRadioButtonList(rbPwd, dr["NDL_PWD"].ToString());

                //2014.11.05 웹하드, 대용량 첨부 기본설정 보여주기
                UserDefaultSize = System.Configuration.ConfigurationSettings.AppSettings["UserDefaultSize"];
                DownLimitDay = System.Configuration.ConfigurationSettings.AppSettings["DownLimitDay"];
                DownLimitCount = System.Configuration.ConfigurationSettings.AppSettings["DownLimitCount"];

                BigFileDefaultSize = System.Configuration.ConfigurationSettings.AppSettings["BigFileDefaultSize"];
                BigFileDownLimitDay = System.Configuration.ConfigurationSettings.AppSettings["BigFileDownLimitDay"];
                BigFileDownLimitCount = System.Configuration.ConfigurationSettings.AppSettings["BigFileDownLimitCount"];

                //2015.12.23 첨부파일 미리보기 기능 추가
                Common.SetRadioButtonList(rbDoc, strDoc);

                //2017.06.12  메일을 백업할 때 제목으로 파일명 백업 기능 추가
                Common.SetRadioButtonList(rbFileName, strFileName);

            }
        }
        finally
        {
            Con.Close();
        }
    }

    protected void btnModifyDomain_Click(Object sender, EventArgs e)
    {
        string strDomain = tbDomain.Text;
        string strAllocateSize = tbAllocateSize.Text;
        string strUserCount = tbUserCount.Text;
        string strDefaultSize = tbDefaultSize.Text;
        string strJoinType = rblJoinType.SelectedValue;
        string strPop3Allow = rblPop3Allow.SelectedValue;
        string strUseGroup = rblUseGroup.SelectedValue;
        string strCopyright = tbCopyright.Text;
        
        //2010.12.27 impa4추가
        string strImpa4Allow = rblImap4Allow.SelectedValue;

        if (strDomain.Trim() == "")
        {
            JS.MessageBox("도메인이 입력되지 않았습니다.");
            JS.HistoryBack();
        }

        if (strAllocateSize.Trim() == "")
        {
            JS.MessageBox("할당용량을 입력해 주세요.");
            JS.HistoryBack();
        }

        if (strUserCount.Trim() == "")
        {
            JS.MessageBox("사용자 할당수를 입력해 주세요.");
            JS.HistoryBack();
        }

        if (strDefaultSize.Trim() == "")
        {
            JS.MessageBox("가입시 기본용량을 입력해 주세요.");
            JS.HistoryBack();
        }

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" + err.Message);
            JS.HistoryBack();
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prModifyDomain";

            #region 2011.08.25 선언 방식을 수정함.
            /// <summary>
            /// 2011.08.25 선언 방식을 수정함.
            /// </summary>

            /*
            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            sParams = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iAllocateSize", OleDbType.Integer, strAllocateSize.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iUserCount", OleDbType.Integer, strUserCount.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strJoinType", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@iDefaultSize", OleDbType.Integer, strDefaultSize.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strPop3Allow", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            //2010.12.27 impa4추가
            sParams = Cmd.Parameters.Add("@strImap4Allow", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strUseGroup", OleDbType.Char, 1);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strCopyright", OleDbType.VarWChar, strCopyright.Length);
            sParams.Direction = ParameterDirection.Input;

            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            sParams.Direction = ParameterDirection.Output;

            Cmd.Parameters["@iAllocateSize"].Value = int.Parse(strAllocateSize);
            Cmd.Parameters["@iUserCount"].Value = int.Parse(strUserCount);
            Cmd.Parameters["@strJoinType"].Value = strJoinType;
            Cmd.Parameters["@iDefaultSize"].Value = int.Parse(strDefaultSize);
            Cmd.Parameters["@strPop3Allow"].Value = strPop3Allow;
            //2010.12.27 impa4추가
            Cmd.Parameters["@strImap4Allow"].Value = strImpa4Allow;
            Cmd.Parameters["@strUseGroup"].Value = strUseGroup;
            Cmd.Parameters["@strCopyright"].Value = strCopyright;
             
            */
            #endregion

            sParams = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            sParams.Direction = ParameterDirection.ReturnValue;

            Cmd.Parameters.Add("@strDomain", OleDbType.VarWChar).Value = strDomain;
            Cmd.Parameters.Add("@iAllocateSize", OleDbType.BigInt).Value = int.Parse(strAllocateSize);
            Cmd.Parameters.Add("@iUserCount", OleDbType.Integer).Value = int.Parse(strUserCount);
            Cmd.Parameters.Add("@strJoinType", OleDbType.Char).Value = strJoinType;
            Cmd.Parameters.Add("@iDefaultSize", OleDbType.BigInt).Value = int.Parse(strDefaultSize);
            Cmd.Parameters.Add("@strPop3Allow", OleDbType.Char).Value = strPop3Allow;
            Cmd.Parameters.Add("@strImap4Allow", OleDbType.Char).Value = strImpa4Allow;
            Cmd.Parameters.Add("@strUseGroup", OleDbType.Char).Value = strUseGroup;

            //2011.08.25 추가 웹사이트명,회사,도메인관리자 연락처,메일주소,회원가입버튼,ssl 여부
            Cmd.Parameters.Add("@strWebname", OleDbType.VarWChar).Value = tbWebName.Text;
            Cmd.Parameters.Add("@strCompany", OleDbType.VarWChar).Value = tbCompany.Text;
            Cmd.Parameters.Add("@strTel", OleDbType.VarChar).Value = tbTel.Text;
            Cmd.Parameters.Add("@strMail", OleDbType.VarWChar).Value = tbmail.Text;
            Cmd.Parameters.Add("@strJoin", OleDbType.Char).Value = rbJoin.SelectedValue;
            Cmd.Parameters.Add("@strSsl", OleDbType.Char).Value = rbSsl.SelectedValue;
            //2011.08.25여기까지

            //2012.01.10 비밀번호 강화 추가
            Cmd.Parameters.Add("@strPwd", OleDbType.Char).Value = rbPwd.SelectedValue;

            //2015.12.23 첨부파일 미리보기 기능 추가
            Cmd.Parameters.Add("@strDoc", OleDbType.Char).Value = rbDoc.SelectedValue;

            //2017.06.12  메일을 백업할 때 제목으로 파일명 백업 기능 추가
            Cmd.Parameters.Add("@strFileName", OleDbType.Char).Value = rbFileName.SelectedValue;

            Cmd.Parameters.Add("@strCopyright", OleDbType.VarWChar).Value = strCopyright;
            
            sParams = Cmd.Parameters.Add("@strReturnValue", OleDbType.VarChar, 600);
            sParams.Direction = ParameterDirection.Output;

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                Trans.Rollback();
                JS.MessageBox(Cmd.Parameters["@strReturnValue"].Value.ToString());
                JS.HistoryBack();
                return;
            }

            Trans.Commit();
        }
        catch (Exception err)
        {
            Trans.Rollback();
            JS.MessageBox(err.Message);
            JS.HistoryBack();
        }
        finally
        {
            Con.Close();
        }

        JS.MessageBox(strMfDomain + " 도메인 정보가 수정되었습니다.");
        JS.MovePage("ModifyDomain.aspx?dm=" + strMfDomain);
    }
}
