﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;

public partial class Config_MailBox_RestoreMail : System.Web.UI.Page
{
    private UserInfo UI;
    private JavaScript JS;
    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailBox = "";
    private string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../../log/login.aspx", true);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        strMailBox = Request.Params["strMailBox"];
        strUserId = Session["USER_ID"].ToString();

        string strScript = "if (!Restore()) return false; else return true;";
        ibRestoreMail.Attributes.Add("onclick", strScript);
    }

    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        string strCompressFile = "";

        if (tbCompressFile.PostedFile != null)
        {
            strCompressFile = tbCompressFile.Value;

            if (strCompressFile != "")
            {
                FileInfo fi = new FileInfo(strCompressFile);

                if (fi.Extension.ToLower() == ".zip")
                {
                    strCompressFile = Path.GetFileName(strCompressFile);
                    tbCompressFile.PostedFile.SaveAs(UI.UserPath + "\\temp\\" + strCompressFile);
                    this.ExtractFile(strCompressFile);
                }
                else
                {
                    JS.MessageBox(fi.Name + " 파일은 zip형식으로된 압축파일이 아닙니다.");
                    JS.HistoryBack();
                    return;
                }

                
                JS.MovePage("ListMailBox.aspx", "opener.document");
                JS.WindowsClose();
                return;
            }
            else
            {
                JS.MessageBox("복구할 메일이 압축된 압축파일을 선택해 주세요.");
                JS.HistoryBack();
                return;
            }
        }
    }

    private void ExtractFile(string strCompressFile)
    {
        sbyte[] buf = new sbyte[1024];
        string strExtractFile = UI.UserPath + "\\temp\\" + strCompressFile;
        int len = 0;
        long useSize = 0;
        bool bSuccess = true;

        if (File.Exists(strExtractFile))
        {
            try
            {
                java.io.FileInputStream fis = new java.io.FileInputStream(strExtractFile);
                java.util.zip.ZipInputStream zis = new java.util.zip.ZipInputStream(fis);
                java.util.zip.ZipEntry ze;

                if (!Directory.Exists(UI.UserPath + "\\Comp"))
                    Directory.CreateDirectory(UI.UserPath + "\\Comp");

                Passkorea.DbMail.DbMail dbMail = new Passkorea.DbMail.DbMail();

                useSize = UI.GetUseMailSize();

                while ((ze = zis.getNextEntry()) != null)
                {
                    //2012.03.29 파일명에 공백이 들어가면 문제가 발생할수가 있어서 공백을 _ 로 변환되어 들어가도록 수정함.
                    string strFilename = ze.getName().Replace(" ", "_");

                    int idx = strFilename.LastIndexOf('/');

                    if (idx > 1)
                    {
                        string folder = strFilename.Substring(0, idx);
                        DirectoryInfo di = new DirectoryInfo(folder);

                        if (!di.Exists)
                            di.Create();
                    }

                    java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\Comp\\" + strFilename);

                    while ((len = zis.read(buf)) >= 0)
                        fos.write(buf, 0, len);

                    fos.close();

                    long fileSize = new FileInfo(UI.UserPath + "\\Comp\\" + strFilename).Length;

                    useSize += fileSize;

                    

                    //2010.10.01 용량 계산 하는 부분에서 문제가 있음.그래서 수정함. 
                    long templong = 1048576;
                    long iMza = UI.UserMailBoxSize * templong;

                    //if ((UI.UserMailBoxSize * 1048576) > useSize)
                    if (iMza > useSize)
                    {
                        // 메일용량을 체크한다.
                        // 압축푼 메일파일을 DB에 저장한다.
                        dbMail.DbCon = strCon;
                        dbMail.UserId = strUserId;
                        dbMail.Domain = strDomain;
                        dbMail.MailboxIdx = int.Parse(strMailBox);
                        dbMail.MailFilePath = UI.UserPath + "\\Comp\\" + strFilename;

                        //2010.04.23 테스트중(메일 파일명에 같은 아이디가 있어서 문제가 있음.)
                        if (dbMail.InsertDbMail(UI.UserPath))
                        {
                            if (!Directory.Exists(dbMail.MoveMailBox))
                                Directory.CreateDirectory(dbMail.MoveMailBox);

                            File.Move(UI.UserPath + "\\Comp\\" + strFilename, dbMail.MoveMailBox + "\\" + dbMail.MoveMailFile);
                        }
                        else
                        {
                            if (!dbMail.ExistsMail)
                            {
                                if (!Directory.Exists(UI.UserPath + "\\Error"))
                                    Directory.CreateDirectory(UI.UserPath + "\\Error");

                                File.Move(UI.UserPath + "\\Comp\\" + strFilename, UI.UserPath + "\\Error\\" + strFilename);

                                if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                                    File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                                FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                                StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                                string strMsg = "[" + DateTime.Now.ToString() + "]\t" + strFilename + "\t" + dbMail.ErrorMessage + "\r\n\r\n";

                                sw.Write(strMsg);
                                sw.Close();
                                fs.Close();
                            }
                            else
                                File.Delete(UI.UserPath + "\\Comp\\" + strFilename);
                        }
                    }
                    else
                    {
                        if (!Directory.Exists(UI.UserPath + "\\Error"))
                            Directory.CreateDirectory(UI.UserPath + "\\Error");

                        if (!File.Exists(UI.UserPath + "\\Error\\ReportErrorMail.txt"))
                            File.Create(UI.UserPath + "\\Error\\ReportErrorMail.txt").Close();

                        FileStream fs = new FileStream(UI.UserPath + "\\Error\\ReportErrorMail.txt", FileMode.Append, FileAccess.Write);
                        StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);

                        string strMsg = "[" + DateTime.Now.ToString() + "]\tallow size limit!\tallow size: " + UI.UserMailBoxSize.ToString() + " MB\tUse Size: " + fileSize.ToString() + " Byte\r\n\r\n";

                        sw.Write(strMsg);
                        sw.Close();
                        fs.Close();

                        bSuccess = false;
                        break;
                    }
                } 

                zis.close();
                fis.close();

                if (File.Exists(strExtractFile))
                    File.Delete(strExtractFile);

                if (Directory.Exists(UI.UserPath + "\\Comp"))
                    Directory.Delete(UI.UserPath + "\\Comp", true);
            }
            catch (Exception err)
            {
                JS.MessageBox("압축파일을 해제 하는 도중 오류가 발생했습니다.\r\n" + err.Message);
                JS.HistoryBack();
                return;
            }
            finally
            {
            }

            if (!bSuccess)
                JS.MessageBox("제한용량인 " + UI.UserMailBoxSize.ToString() + " MB를 초과하여 더이상 메일을 복구할 수 없습니다.");
            else
                JS.MessageBox("해당 편지함이 복구되었습니다.");
        }
    }
}
