﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Globalization;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class Mail_MailBackup : System.Web.UI.Page
{
    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();
    private JavaScript JS;
    private UserInfo UI;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strMailBox = "";
    private string strMailIdx = "";

    protected string strDomain = "";
    protected string strUserId = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        strDomain = Session["MAIL_DOMAIN"].ToString();
        UI = new UserInfo(Session["USER_ID"].ToString(), strDomain, strCon);
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["mailbox"];
        strMailIdx = Request.Params["mailIdx"];

        MailBackup();
    }

    private void MailBackup()
    {
        string strMailId = "";
        string strCompressFile = "";
        bool bFile = false;

        if (strMailIdx == "")
        {
            JS.MessageBox("백업할 메일을 선택해 주세요.");
            JS.HistoryBack();
            return;
        }

        // 백업할 파일명을 사용자 아이디 + Sel + 메일박스 명으로 백업한다.
        strCompressFile = strUserId + "_" + DateTime.Now.ToString("yyyyMMdd") + "_" + strMailBox + ".zip";

        if (strMailIdx != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return;
            }
            
            try
            {
                //2017.06.08 파일명 다운로드 받기 옵션으로 추가
                string strNdlName = SetupModify.select("SELECT NDL_FILE_NAME FROM NM_DOMAIN_LIST WHERE NDL_DOMAIN = '" + strDomain + "'");

                strMailId = strMailIdx.Replace("|", ",");

                if (strMailId.EndsWith(","))
                    strMailId = strMailId.Substring(0, strMailId.Length - 1);

                Cmd.Connection = Con;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prSelectMailFile";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar, strMailId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strMailIdx"].Value = strMailId;
                Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

                Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "NM_MAIL_LIST");
                dt = ds.Tables["NM_MAIL_LIST"];

                if (dt != null)
                {

                    // 압축을 하기위에 자바 라이브러리에 포함되어 있는 Zip 압축 관련 라이브러리를 끌어쓴다.
                    // 단, 자바 라이브러리를 사용하기 위해서는 MS Visual J# .Net 재배포 패키지를 설치해야
                    // 자바 라이브러리를 사용할 수 있다.
                    java.io.FileOutputStream fos = new java.io.FileOutputStream(UI.UserPath + "\\" + strCompressFile);
                    java.util.zip.ZipOutputStream zos = new java.util.zip.ZipOutputStream(fos);

                    foreach (DataRow dr in dt.Rows)
                    {
                        string filePath = UI.UserPath + "\\" + dr["Mc_Mailbox_No"].ToString();
                        string filename = dr["Mc_Filename"].ToString();
                        string subject = dr["MC_Subject"].ToString();
                        string idx = dr["Mc_Idx"].ToString();

                        //2017.06.08 파일명 다운로드 받기 옵션으로 추가
                        if (strNdlName == "Y")
                        {
                            StringInfo Si = new System.Globalization.StringInfo(subject);

                            if (Si.LengthInTextElements > 200)
                            {
                                subject = Si.SubstringByTextElements(0, 200);
                            }

                            subject = idx + "_" + subject + ".eml";
                        }
                        else
                        {
                            subject = filename;
                        }


                        if (File.Exists(filePath + "\\" + filename))
                        {
                            bFile = true;
                            java.io.FileInputStream fis = new java.io.FileInputStream(filePath + "\\" + filename);
                            java.util.zip.ZipEntry ze = new java.util.zip.ZipEntry(subject);
                            zos.putNextEntry(ze);

                            sbyte[] buf = new sbyte[1024];
                            int len = 0;

                            while ((len = fis.read(buf)) >= 0)
                                zos.write(buf, 0, len);

                            zos.closeEntry();
                            fis.close();
                        }
                    }

                    zos.close();
                    fos.close();

                    if (!bFile)
                        File.Delete(UI.UserPath + "\\" + strCompressFile);
                }
            }
            catch (Exception err)
            {
                Con.Close();
                JS.MessageBox("선택한 편지를 백업하는 도중 오류가 발생했습니다.\r\n" +
                    "서버관리자에게 문의 하세요.\r\n" + err.Message);
                return;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            if (bFile)
            {
                FileInfo f = new FileInfo(UI.UserPath + "\\" + strCompressFile);

                Response.Clear();
                Response.ClearContent();
                Response.ContentType = "Application/Octet-stream";

                //2011.02.24 안드로이드에서 다운로드 안되서 수정함.
                //2010.09.15 안드로이드에서도 다운로드 가능하도록 다운로드 로직 수정함.

                //Response.AppendHeader("Content-Disposition", "attachment; filename=" + strCompressFile);
                //Response.WriteFile(f.FullName);
                //Response.End();

                //Response.AppendHeader("Content-Disposition", "attachment;\tfilename=\"" + strCompressFile + "\";");
                Response.AppendHeader("Content-Disposition", "attachment;filename=\"" + strCompressFile + "\"");
                Response.AddHeader("Content-Length", f.Length.ToString());
                Response.TransmitFile(f.FullName);
                Response.Flush();
                Response.End();
            }
            else
            {
                JS.MessageBox("선택한 메일에 대한 원문이 존재하지 않아서 메일을 백업할수 없습니다.");
                Response.End();
            }
        }
    }
}
