﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.Globalization;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Text.RegularExpressions;
using Passkorea;
using Passkorea.MailParse;

public partial class Mail_MailButton : System.Web.UI.UserControl
{
    private UserInfo UI;
    private JavaScript JS;

    private OleDbConnection Con;
    private OleDbTransaction Trans;
    private OleDbCommand Cmd = new OleDbCommand();
    private OleDbParameter Param = new OleDbParameter();
    private OleDbDataAdapter Adap;
    private DataSet ds = new DataSet();
    private DataTable dt = new DataTable();

    private string strDomain = "";
    private string strCon = ConfigurationSettings.AppSettings["strConnection"];
    private string strUserId = "";
    private string iPage = "";
    private string strPort = "";
    protected string mailId = "";
    protected string strMailBox = "";
    protected string strUrl = "";
    protected string strPrevMail = "";
    protected string strNextMail = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        // 여기에 사용자 코드를 배치하여 페이지를 초기화합니다.
        JS = new JavaScript(this.Page);
        
        strDomain = Session["MAIL_DOMAIN"].ToString();
        strUserId = Session["USER_ID"].ToString();
        strMailBox = Request.Params["mailbox"];
        mailId = Request.Params["mailId"];
        iPage = Request.Params["iPage"];

        UI = new UserInfo(strUserId, strDomain, strCon);

        if (!Page.IsPostBack)
        {
            strPort = Request.Url.Port.ToString();
            strUrl = Request.Url.LocalPath;
            strUrl = strUrl.Substring(0, strUrl.LastIndexOf("/") + 1);

            //2011.11.23
            //ssl일때 아래 로직이 문제가 있어서 수정을 함.
            string strhttp = Request.ServerVariables["HTTPS"].ToString();

            if (strhttp == "off")
                strhttp = "http://";
            else
                strhttp = "https://";

            // 2006년 11월 22일 수정
            // 포트가 변경되어 있을 경우에 주소 뒤에 포트 번호를 붙여준다.
            if (strPort != "80")
                strUrl = strhttp + Request.ServerVariables["SERVER_NAME"] + ":" + strPort + strUrl;
            //strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + ":" + strPort + strUrl;
            else
                strUrl = strhttp + Request.ServerVariables["SERVER_NAME"] + strUrl;
                //strUrl = "http://" + Request.ServerVariables["SERVER_NAME"] + strUrl;

            ibReply.ImageUrl = strUrl + ibReply.ImageUrl;
            ibDeleteMail.ImageUrl = strUrl + ibDeleteMail.ImageUrl;
            ibMailList.ImageUrl = strUrl + ibMailList.ImageUrl;
            ibAllReply.ImageUrl = strUrl + ibAllReply.ImageUrl;
            ibForward.ImageUrl = strUrl + ibForward.ImageUrl;

            this.MailboxData_Bind();

            if (strMailBox.ToLower() == "201")
            {
                ibRestoreMail.Visible = true;
                ibReply.Visible = false;
                ibForward.Visible = false;
            }
        }
        
        this.GetMailList();
        Page.DataBind();
    }

    #region 메일박스 데이터 바인드
    private void MailboxData_Bind()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox("DB Connection Fail!!!\r\n" +
                err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prListMailBox";

            Cmd.Parameters.Clear();

            // Command Parameter (User Id)
            Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            // Command Parameter (Domain)
            Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsDefault", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strIsMainView", OleDbType.Char, 1);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@varUserId"].Value = strUserId;
            Cmd.Parameters["@varDomain"].Value = strDomain;
            Cmd.Parameters["@strIsDefault"].Value = "";
            Cmd.Parameters["@strIsMainView"].Value = "";

            Adap = new OleDbDataAdapter(Cmd);
            Adap.Fill(ds, "MAIL_BOX");
            dt = ds.Tables["MAIL_BOX"];

            foreach (DataRow dr in dt.Rows)
            {
                int iDepth = int.Parse(dr["M_Depth"].ToString());
                string strIdx = dr["M_Idx"].ToString();
                string strMailboxName = dr["M_MAILBOX_NAME"].ToString();

                if (iDepth > 0)
                {
                    strMailboxName = "┗" + strMailboxName;

                    for (int i = 0; i < iDepth; i++)
                        strMailboxName = Server.HtmlDecode("&nbsp;") + strMailboxName;
                }

                ListItem li = new ListItem(strMailboxName, strIdx);
                ddlMailbox.Items.Add(li);

            }

            ddlMailbox.DataBind();
        }
        catch (Exception err)
        {
            JS.MessageBox("편지함 정보를 가져오는 도중 오류가 발생했습니다.\r\n" +
                err.Message);
            return;
        }
        finally
        {
            Con.Close();
        }
    }
    #endregion

    #region 메일 복원
    /// <summary>
    /// 메일 복원
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibRestoreMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (mailId != "" && strMailBox != "")
        {
            if (strMailBox == "201")
            {
                if (!MailMove("1"))
                    return;
            }
        }

        JS.MessageBox("읽고 있던 메일을 복구 하였습니다.");
        JS.MovePage("ListMail.aspx?mailbox=" + strMailBox);
    }
    #endregion

    #region 메일 삭제
    /// <summary>
    /// 메일 삭제
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibDeleteMail_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (mailId != "" && strMailBox != "")
        {
            if (strMailBox == "201")
            {
                if (!DeleteMail())
                    return;
            }
            else
            {
                if (!MailMove("201"))
                    return;
            }
        }

        //JS.MessageBox("읽고 있던 메일이 삭제 되었습니다.");
        JS.MovePage("ListMail.aspx?mailbox=" + strMailBox + "&iPage=" + iPage);
    }
    #endregion

    #region 메일 삭제
    /// <summary>
    /// DB에 있는 메일과 메일 원문을 삭제한다.
    /// </summary>
    /// <returns></returns>
    private bool DeleteMail()
    {
        string mailname = "";
        string mailbox = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
            Trans = Con.BeginTransaction();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return false;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.Transaction = Trans;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prDeleteMail";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Output;

            Param = Cmd.Parameters.Add("@strMailFile", OleDbType.VarChar, 255);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMcIdx"].Value = int.Parse(mailId);

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                if (iResult == -1)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("사용자 정보가 없습니다.");
                    return false;
                }
                else if (iResult == -2)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                    return false;
                }
                else if (iResult == -3)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                    return false;
                }
            }

            mailbox = Cmd.Parameters["@iMailboxIdx"].Value.ToString();
            mailname = Cmd.Parameters["@strMailFile"].Value.ToString();

            Trans.Commit();
        }
        catch (Exception e)
        {
            Trans.Rollback();
            Con.Close();
            JS.MessageBox("읽고 있던 메일을 삭제하는 도중 오류가 발생했습니다.\r\n" + e.Message);
            return false;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        if (File.Exists(UI.UserPath + "\\" + mailbox + "\\" + mailname))
            File.Delete(UI.UserPath + "\\" + mailbox + "\\" + mailname);

        return true;
    }
    #endregion

    #region 메일 리스트로 이동
    /// <summary>
    /// 메일 리스트로 이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibMailList_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        if (strMailBox.Trim() == "")
            strMailBox = "1";

        Response.Redirect("ListMail.aspx?mailbox=" + strMailBox + "&iPage=" + iPage);
    }
    #endregion

    #region 회신
    /// <summary>
    /// 회신
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibReply_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("re");
    }
    #endregion

    #region 전체회신
    /// <summary>
    /// 전체회신
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibAllReply_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("ar");
    }
    #endregion

    #region 전달
    /// <summary>
    /// 전달
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibForward_Click(object sender, System.Web.UI.ImageClickEventArgs e)
    {
        this.MailWrite("fw");
    }
    #endregion

    #region 편지쓰기
    /// <summary>
    /// 편지쓰기
    /// </summary>
    /// <param name="strType"></param>
    protected void MailWrite(string strType)
    {
        Response.Redirect("WriteMail.aspx?mailid=" + mailId + "&Mailbox=" + strMailBox + "&Type=" + strType);
    }
    #endregion

    #region 원문 다운받기
    /// <summary>
    /// 원문 다운받기
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void lbOrgMailDownload_DownCommand(object sender, EventArgs e)
    {
        string mailboxNo = "";
        string mailname = "";
        string Subject = "";
        string strEnc = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewMailContent";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMcIdx"].Value = int.Parse(mailId);
            Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

            OleDbDataReader reader = Cmd.ExecuteReader();

            if (reader.HasRows)
            {
                reader.Read();
                mailname = reader["Mc_Filename"].ToString();
                mailboxNo = reader["Mc_Mailbox_No"].ToString();
                Subject = reader["MC_Subject"].ToString();

                StringInfo Si = new System.Globalization.StringInfo(Subject);

                if (Si.LengthInTextElements > 200)
                {
                    Subject = Si.SubstringByTextElements(0, 200);
                }
            }

            reader.Close();
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        if (File.Exists(UI.UserPath + "\\" + mailboxNo + "\\" + mailname))
        {
            try
            {
                string strMailPath = "";
                string line = "";
                //2017.06.08 파일명 다운로드 받기 옵션으로 추가
                string strNdlName = SetupModify.select("SELECT NDL_FILE_NAME FROM NM_DOMAIN_LIST WHERE NDL_DOMAIN = '" + strDomain + "'");

                if (UI.UserPath.LastIndexOf("\\") == UI.UserPath.Length)
                    strMailPath = UI.UserPath + mailboxNo + "\\" + mailname;
                else
                    strMailPath = UI.UserPath + "\\" + mailboxNo + "\\" + mailname;

                if (!System.IO.File.Exists(strMailPath))
                {
                    //throw new ParseHeaderException("다운로드 하려는 파일이 존재하지 않습니다.\r\n다운로드 파일명: " + strMailFile + "\r\n");
                    JS.MessageBox("다운로드 하려는 파일이 존재하지 않습니다.\r\n다운로드 파일명: " + mailname);
                    return;
                }

                FileStream fs = new FileStream(strMailPath, FileMode.Open);
                using (TextReader tr = new StreamReader(fs, System.Text.Encoding.Default, true))
                {
                    //2017.02.21 원문 다운로드 파일명 관련 정규식 적용
                    Subject = System.Text.RegularExpressions.Regex.Replace(Subject, "[\\\\/:*?\"<>|]", "_").Replace("\r\n", "");

                    strEnc = HttpUtility.UrlEncode(Subject + ".eml", new System.Text.UTF8Encoding()).Replace("%20", "\"").Replace("+", "_").Replace("__", "_");

                    Response.Clear();
                    Response.ClearContent();
                    Response.ContentType = "Application/Octet-stream";

                    //2010.09.15 안드로이드에서 다운로드 이상하게 되는 부분 수정함.
                    //Response.AddHeader("Content-Disposition", "attachment;\tfilename=\"" + HttpUtility.UrlEncode(mailname, new System.Text.UTF8Encoding()).Replace(" ", "%20") + "\"");

                    //2017.06.08 파일명 다운로드 받기 옵션으로 추가
                    if (strNdlName == "Y")
                    {
                        //Response.AppendHeader("Content-Disposition", "attachment;\tfilename=\"" + HttpUtility.UrlEncode(mailname, new System.Text.UTF8Encoding()).Replace(" ", "%20") + "\"");
                        //2017.01.19 메일 제목으로 파일 저장하게 수정
                        Response.AppendHeader("Content-Disposition", "attachment;\tfilename=\"" + strEnc + "\"");
                    }
                    else
                    {
                        Response.AppendHeader("Content-Disposition", "attachment;\tfilename=\"" + HttpUtility.UrlEncode(mailname, new System.Text.UTF8Encoding()).Replace(" ", "%20") + "\"");
                    }

                    line = tr.ReadLine();

                    while (line != null)
                    {
                        Response.BinaryWrite(System.Text.Encoding.Default.GetBytes(line + "\r\n"));
                        Response.Flush();
                        line = tr.ReadLine();
                    }
                    tr.Close();
                }
                fs.Close();
            }
            catch (Exception err)
            {
                //throw new ParseHeaderException("메일 원문 다운로드중 오류 발생\r\n" + err.Message);
                JS.MessageBox("메일 원문 다운로드중 오류 발생\r\n" + err.Message);
                return;
            }
            Response.End();
            return;
        }
        else
        {
            JS.MessageBox("메일 원문이 서버에 존재하지 않습니다.");
            JS.HistoryBack();
            return;
        }
    }
    #endregion

    #region 메일이동 버튼
    /// <summary>
    /// 메일이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibMoveMail_Click(object sender, ImageClickEventArgs e)
    {
        string strMoveMailbox = ddlMailbox.SelectedValue;
        
        //2011.04.04 현재 페이지로 이동으로 수정함.
        if (MailMove(strMoveMailbox))
            //JS.MovePage("ViewMail.aspx?mailId=" + mailId + "&mailbox=" + strMoveMailbox);
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox + "&iPage=" + iPage);

        return;
    }
    #endregion
    //2015.06.08 메일 계속 이동 추가
    #region 메일 계속 이동 버튼
    /// <summary>
    /// 메일이동
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void ibMoveMail2_Click(object sender, ImageClickEventArgs e)
    {
        string strMoveMailbox = ddlMailbox.SelectedValue;

        //2011.04.04 현재 페이지로 이동으로 수정함.
        if (AddFilter(strMoveMailbox) && MailMove(strMoveMailbox))
            //JS.MovePage("ViewMail.aspx?mailId=" + mailId + "&mailbox=" + strMoveMailbox);
            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox + "&iPage=" + iPage);

        return;
    }
    #endregion

    #region 메일 이동
    /// <summary>
    /// DB에 저장되어 있는 메일박스 정보를 변경한다.
    /// </summary>
    /// <param name="strTargetBox"></param>
    /// <returns></returns>
    private bool MailMove(string strTargetBox)
    {
        if (strTargetBox.Trim() != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return false;
            }

            try
            {
                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;
                Cmd.CommandText = "prMoveMailbox";

                Cmd.Parameters.Clear();

                Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                Param.Direction = ParameterDirection.ReturnValue;

                Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@strMailIdx", OleDbType.VarChar, mailId.Length);
                Param.Direction = ParameterDirection.Input;

                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                Param.Direction = ParameterDirection.Input;

                Cmd.Parameters["@strUserId"].Value = strUserId;
                Cmd.Parameters["@strDomain"].Value = strDomain;
                Cmd.Parameters["@strMailIdx"].Value = mailId;
                Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strTargetBox);

                Cmd.ExecuteNonQuery();

                int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                if (iResult != 0)
                {
                    if (iResult == -1)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox("사용자 정보가 없습니다.");
                        return false;
                    }
                    else if (iResult == -2)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                        return false;
                    }
                    else if (iResult == -3)
                    {
                        Trans.Rollback();
                        Con.Close();
                        JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                        return false;
                    }
                }

                Trans.Commit();
            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox(err.Message);
                return false;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            return true;
        }
        else
            return false;
    }
    #endregion

    //2015.06.08 메일 계속 이동을 위한 필터링 추가
    #region 메일 계속 이동을 위한 필터링 추가
    /// <summary>
    /// DB에 보낸 사람을 기준으로 필터링에 추가한다.
    /// </summary>
    /// <param name="strTargetBox"></param>
    /// <returns></returns>
    private bool AddFilter(string strTargetBox)
    {
        string[] arrMailFile = null;
        string strFilterEmail = "";
        string readerFilterEmail = "";
        int iResult = 0;

        if (strTargetBox.Trim() != "")
        {
            try
            {
                Con = new OleDbConnection(strCon);
                Con.Open();
                Trans = Con.BeginTransaction();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                return false;
            }

            try
            {
                arrMailFile = mailId.Split('|');

                Cmd.Connection = Con;
                Cmd.Transaction = Trans;
                Cmd.CommandType = CommandType.StoredProcedure;

                if (mailId != "")
                {
                    for (int i = 0; i < arrMailFile.Length; i++)
                    {

                        Cmd.CommandText = "prViewMailContent";

                        Cmd.Parameters.Clear();
                        Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
                        Param.Direction = ParameterDirection.ReturnValue;

                        Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
                        Param.Direction = ParameterDirection.Input;

                        Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
                        Param.Direction = ParameterDirection.Input;

                        Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
                        Param.Direction = ParameterDirection.Input;

                        Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                        Param.Direction = ParameterDirection.Input;

                        Cmd.Parameters["@strUserId"].Value = strUserId;
                        Cmd.Parameters["@strDomain"].Value = strDomain;
                        Cmd.Parameters["@iMcIdx"].Value = int.Parse(arrMailFile[i]);
                        Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

                        OleDbDataReader reader = Cmd.ExecuteReader();

                        if (Cmd.Parameters["@iResult"].Value != null)
                        {
                            iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

                            // 에러처리
                        }
                        else
                        {                            
                            if (reader.HasRows)
                            {
                                reader.Read();
                                strFilterEmail = reader["Mc_From"].ToString();
                            }
                        }

                        reader.Close();

                        //선택된 메일주소가 등록되어 있으면 패스하기 위해 Filter 목록을 가져옴
                        Cmd.CommandText = "prListUserFiltering";

                        Cmd.Parameters.Clear();

                        // 사용자 아이디
                        Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                        Param.Direction = ParameterDirection.Input;
                        // 도메인
                        Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                        Param.Direction = ParameterDirection.Input;

                        Cmd.Parameters["@varUserId"].Value = strUserId;
                        Cmd.Parameters["@varDomain"].Value = strDomain;

                        Adap = new OleDbDataAdapter(Cmd);

                        Adap.Fill(ds, "NM_USER_FILTER");
                        dt = ds.Tables["NM_USER_FILTER"];

                        foreach (DataRow dr in dt.Rows)
                        {
                            readerFilterEmail += dr["NUF_WORD"].ToString();
                        }
                        // 메일주소 외에 다른 문자는 제거한다.
                        // 이름 또는 <> 문자를 제거한다.
                        if (strFilterEmail.LastIndexOf(" ") > -1 || strFilterEmail.LastIndexOf(">") > -1)
                        {
                            int iPos = 0;
                            strFilterEmail = strFilterEmail.Substring(strFilterEmail.LastIndexOf(" ") + 1);

                            iPos = strFilterEmail.LastIndexOf("|");
                            if (iPos > 0)
                                strFilterEmail = strFilterEmail.Substring(iPos + 1);

                            iPos = strFilterEmail.IndexOf("<");
                            if (iPos > 0)
                                strFilterEmail = strFilterEmail.Substring(iPos + 1);

                            if (strFilterEmail.StartsWith("<"))
                                strFilterEmail = strFilterEmail.Substring(1);

                            iPos = strFilterEmail.LastIndexOf(">");
                            if (iPos > 0)
                                strFilterEmail = strFilterEmail.Substring(0, iPos);
                        }
                        
                        // 메일주소 유효성 검사를 하기 위해서 사용함.
                        Regex regex = new Regex(chk_mail.Text);
                        MatchCollection mc = regex.Matches(strFilterEmail);

                        if (mc.Count > 0)
                        {
                            if (readerFilterEmail.IndexOf(strFilterEmail) > -1 )
                            {
                                Cmd.CommandText = "prUpdateFilter";

                                Cmd.Parameters.Clear();

                                // Command Parameter (Execute Return Value)
                                Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                                Param.Direction = ParameterDirection.ReturnValue;

                                // Command Parameter (User Id)
                                Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Domain)
                                Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Filtering Word)
                                Param = Cmd.Parameters.Add("@varWords", OleDbType.VarWChar, strFilterEmail.Length);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Filtering Target)
                                Param = Cmd.Parameters.Add("@chrTarget", OleDbType.Char, 2);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Filtering Target Mailbox)
                                Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Filterig Is Use)
                                Param = Cmd.Parameters.Add("@chrIsUse", OleDbType.Char, 1);
                                Param.Direction = ParameterDirection.Input;

                                // Command Parameter (Output Value)
                                Param = Cmd.Parameters.Add("@varRtnVal", OleDbType.VarChar, 100);
                                Param.Direction = ParameterDirection.Output;

                                Cmd.Parameters["@varUserId"].Value = strUserId;
                                Cmd.Parameters["@varDomain"].Value = strDomain;
                                Cmd.Parameters["@varWords"].Value = strFilterEmail;
                                Cmd.Parameters["@chrTarget"].Value = "F3";
                                Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strTargetBox);
                                Cmd.Parameters["@chrIsUse"].Value = "Y";

                                Cmd.ExecuteNonQuery();

                                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                                if (iValue < 0)
                                {
                                    Trans.Rollback();
                                    Con.Close();
                                    JS.MessageBox("편지 자동분류를 수정하는 도중 오류가 발생했습니다.\r\n" +
                                        "오류 내용: " + Cmd.Parameters["@varRtnVal"].Value.ToString());
                                    JS.HistoryBack();
                                    return false;
                                }
                                else if (iValue != 0)
                                {
                                    Trans.Rollback();
                                    Con.Close();
                                    JS.MessageBox("편지 자동분류를 수정하는 도중 오류가 발생했습니다.\r\n" +
                                        "SQL Error Number: " + iValue.ToString());
                                    JS.HistoryBack();
                                    return false;
                                }
                                JS.MessageBox("편지 자동분류를 수정하였습니다.\r\n\r\n - 잘못 등록된 주소는 환경설정 - 편지 자동분류에서 수정이 가능합니다.\r\n\r\n" + "수정된 메일 주소: \r\n" + strFilterEmail);
                            }
                            else
                            {
                                Cmd.CommandText = "prInsertFiltering";

                                Cmd.Parameters.Clear();

                                // 실행 결과값
                                Param = Cmd.Parameters.Add("@iRtnValue", OleDbType.Integer);
                                Param.Direction = ParameterDirection.ReturnValue;

                                // 사용자 아이디
                                Param = Cmd.Parameters.Add("@varUserId", OleDbType.VarChar, strUserId.Length);
                                Param.Direction = ParameterDirection.Input;

                                // 도메인
                                Param = Cmd.Parameters.Add("@varDomain", OleDbType.VarChar, strDomain.Length);
                                Param.Direction = ParameterDirection.Input;

                                // 필터링 단어
                                Param = Cmd.Parameters.Add("@varWords", OleDbType.VarWChar, strFilterEmail.Length);
                                Param.Direction = ParameterDirection.Input;

                                // 필터링 대상
                                Param = Cmd.Parameters.Add("@chrTarget", OleDbType.Char, 2);
                                Param.Direction = ParameterDirection.Input;

                                // 메일 이동(삭제) 폴더
                                Param = Cmd.Parameters.Add("@iMaiboxIdx", OleDbType.SmallInt);
                                Param.Direction = ParameterDirection.Input;

                                // 현재 필터링 사용여부
                                Param = Cmd.Parameters.Add("@chrIsUse", OleDbType.Char, 1);
                                Param.Direction = ParameterDirection.Input;

                                Cmd.Parameters["@varUserId"].Value = strUserId;
                                Cmd.Parameters["@varDomain"].Value = strDomain;
                                Cmd.Parameters["@varWords"].Value = strFilterEmail;
                                Cmd.Parameters["@chrTarget"].Value = "F3";
                                Cmd.Parameters["@iMaiboxIdx"].Value = int.Parse(strTargetBox);
                                Cmd.Parameters["@chrIsUse"].Value = "Y";

                                Cmd.ExecuteNonQuery();

                                int iValue = int.Parse(Cmd.Parameters["@iRtnValue"].Value.ToString());

                                if (iValue != 0)
                                {
                                    Trans.Rollback();
                                    Con.Close();

                                    JS.MessageBox("편지 자동분류를 설정하는 도중 오류가 발생했습니다.\r\n" +
                                        "오류 발생 프로시져: prInsertFiltering\r\n" +
                                        "SQL Error Number: " + iValue.ToString());
                                    return false;
                                }
                                JS.MessageBox(strFilterEmail + "를 편지 자동분류에 설정하였습니다.\r\n\r\n" +
                                "잘못 등록된 주소는 환경설정 - 편지 자동분류에서 설정이 가능합니다.\r\n");
                            }

                        }
                        else
                        {
                            Trans.Rollback();
                            Con.Close();

                            JS.MessageBox("보낸사람 주소가 정확하지 않아 편지 자동분류에 등록되지 않았습니다.\r\n\r\n" +
                                          "보낸사람 주소 : " + strFilterEmail);
                            JS.MovePage("ListMail.aspx?mailbox=" + strMailBox + "&iPage=" + iPage);
                            return false;
                        }
                    }
                    Trans.Commit();

                }
            }
            catch (Exception err)
            {
                Trans.Rollback();
                Con.Close();
                JS.MessageBox(err.Message);
                return false;
            }
            finally
            {
                if (Con.State != ConnectionState.Closed)
                    Con.Close();
            }

            return true;
        }
        else
            return false;
    }
    #endregion

    #region 다음편지, 이전편지 가져오기
    /// <summary>
    /// 다음편지와 이전편지를 가져온다.
    /// </summary>
    private void GetMailList()
    {
        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prNextPrevMail";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;
            
            Param = Cmd.Parameters.Add("@iPrevMailIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Output;

            Param = Cmd.Parameters.Add("@iNextMailIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Output;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMcIdx"].Value = int.Parse(mailId);
            Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

            Cmd.ExecuteNonQuery();

            int iResult = int.Parse(Cmd.Parameters["@iResult"].Value.ToString());

            if (iResult != 0)
            {
                if (iResult == -1)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("사용자 정보가 없습니다.");
                    return;
                }
                else if (iResult == -2)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox(strDomain + " 도메인에 대한 정보가 없습니다.");
                    return;
                }
                else if (iResult == -3)
                {
                    Trans.Rollback();
                    Con.Close();
                    JS.MessageBox("해당 메일에 대한 정보가 없습니다.");
                    return;
                }
            }
            
            strPrevMail = Cmd.Parameters["@iPrevMailIdx"].Value.ToString();
            strNextMail = Cmd.Parameters["@iNextMailIdx"].Value.ToString();

            if (strPrevMail == "0")
                strPrevMail = "";

            if (strNextMail == "0")
                strNextMail = "";
        }
        catch (Exception e)
        {
            Con.Close();
            JS.MessageBox("다음편지, 이전편지 정보값을 가져오는 도중 오류가 발생했습니다.\r\n" + e.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }
    }
    #endregion

    #region 재파싱한다.
    /// <summary>
    /// 재파싱한다/
    /// </summary>
    protected void Mail_Restore_Click(object sender, EventArgs e)
    {

        string mailboxNo = "";
        string mailname = "";

        try
        {
            Con = new OleDbConnection(strCon);
            Con.Open();
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            return;
        }

        try
        {
            Cmd.Connection = Con;
            Cmd.CommandType = CommandType.StoredProcedure;
            Cmd.CommandText = "prViewMailContent";

            Cmd.Parameters.Clear();

            Param = Cmd.Parameters.Add("@iResult", OleDbType.Integer);
            Param.Direction = ParameterDirection.ReturnValue;

            Param = Cmd.Parameters.Add("@strUserId", OleDbType.VarChar, strUserId.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@strDomain", OleDbType.VarChar, strDomain.Length);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMcIdx", OleDbType.Integer);
            Param.Direction = ParameterDirection.Input;

            Param = Cmd.Parameters.Add("@iMailboxIdx", OleDbType.SmallInt);
            Param.Direction = ParameterDirection.Input;

            Cmd.Parameters["@strUserId"].Value = strUserId;
            Cmd.Parameters["@strDomain"].Value = strDomain;
            Cmd.Parameters["@iMcIdx"].Value = int.Parse(mailId);
            Cmd.Parameters["@iMailboxIdx"].Value = int.Parse(strMailBox);

            OleDbDataReader reader = Cmd.ExecuteReader();

            if (reader.HasRows)
            {
                reader.Read();
                mailname = reader["Mc_Filename"].ToString();
                mailboxNo = reader["Mc_Mailbox_No"].ToString();
            }

            reader.Close();
        }
        catch (Exception err)
        {
            JS.MessageBox(err.Message);
            return;
        }
        finally
        {
            if (Con.State != ConnectionState.Closed)
                Con.Close();
        }

        //메일박스idx값 파일경로

        string filename = "";

        filename = UI.UserPath + "\\" + mailboxNo + "\\" + mailname;

        if (File.Exists(filename))
        {
            Passkorea.DbMail.DbMail dbMail = new Passkorea.DbMail.DbMail();

            dbMail.DbCon = strCon;
            dbMail.UserId = strUserId;
            dbMail.Domain = strDomain;
            dbMail.MailboxIdx = int.Parse(strMailBox);
            dbMail.MailFilePath = filename;
            dbMail.UpdateDbMail(mailId);
            
        }
        else
        {
            JS.MessageBox("원본파일이 없습니다. 서버관리자분에 문의하십시오.");
        }




        JS.MovePage("viewMail.aspx?mailbox=" + strMailBox + "&mailId=" + mailId + "&iPage=" + iPage);


    }
    #endregion
}
