﻿using System;
using System.Data;
using System.Data.OleDb;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Passkorea;
using Passkorea.WebSource;

public partial class Webhard_Webhard : System.Web.UI.Page
{
    private WebhardCommon _wc = new WebhardCommon();
    private JavaScript JS;
    protected UserInfo UI;

    private string strCon = ConfigurationSettings.AppSettings["strConnection"].ToString();
    private string strAdminId = ConfigurationSettings.AppSettings["AdminId"].ToString();
    private string strSchValue = "";
    
    public string dir = "";

    protected string strDomain = "";
    protected string strExtFilter = "";
    protected string strMemberId = "";
    protected string strWebhardHeight = "350";
    protected bool bUpload = false;
    protected bool bSearch = false;

    protected string strFileType = "";

    private int OsMajor = 0;
    private int OsMinor = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        JS = new JavaScript(this.Page);
        JS.LoginCheck(Session["USER_ID"], "../Log/login.aspx", false);

        string strScript = "";

        dir = Request.Params["dir"];
        strMemberId = Session["USER_ID"].ToString();
        strDomain = Session["MAIL_DOMAIN"].ToString();

        UI = new UserInfo(strMemberId, strDomain, strCon);

        System.OperatingSystem osInfo = System.Environment.OSVersion;

        OsMajor = osInfo.Version.Major;

        OsMinor = osInfo.Version.Minor;
        
        if (!Page.IsPostBack)
        {
            IpFilter();
        }

        if (txtAttachFile.PostedFile != null)
        {
            AttachFile();
        }

        //현재 유저 업로드 모드를 가져 오는 부분.
        strFileType = UI.File_Up_Type;

        // 폴더 삭제 버튼 속성 추가
        strScript = "if (!DeleteFolder()) return false; else return true;";
        btnDeleteFolder.Attributes.Add("onclick", strScript);

        // 파일 삭제 버튼 속성 추가
        strScript = "if (!DeleteFiles()) return false; else return true;";
        btnDeleteFile.Attributes.Add("onclick", strScript);

        // 검색 버튼 속성 추가
        strScript = "if (!SearchFile()) return false; else return true;";
        btnSearchFile.Attributes.Add("onclick", strScript);

        Page.DataBind();
    }


    #region 업로드 아이피 필터링
    /// <summary>
    /// 아이피로 업로드 하려는 클라이언트를 제한한다.
    /// </summary>
    /// <returns></returns>
    private void IpFilter()
    {
        bool result = false;
        string strRemoteIp = Request.UserHostAddress;
        UploadFilter _filter = new UploadFilter();
        
        _filter.ConnectionString = strCon;

        try
        {
            result = _filter.LoadUploadFilter(strDomain, strAdminId);
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }

        if (!result)
        {
            JS.MessageBox(_filter.ErrorMessage);
            JS.HistoryBack();
            return;
        }

        strExtFilter = _filter.FileExtensions.ToString();

        string[] strIp = strRemoteIp.Split('.');

        // IP Check
        // 2016.04.14 IP Check 하는 부분에 잘못된 값 가져오도록 되어 있어서 수정
        //strRemoteIp = strRemoteIp[0] + "." + strIp[1] + "." + strIp[2] + "." + strIp[3];
        strRemoteIp = strIp[0] + "." + strIp[1] + "." + strIp[2] + "." + strIp[3];

        if (_filter.IpList.IndexOf(strRemoteIp) < 0)
            bUpload = true;

        return;
    }
    #endregion

    #region 폴더 삭제 버튼
    /// <summary>
    /// 폴더를 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteFolder_Click(object sender, EventArgs e)
    {
        bool result = false;
        bool bGroup = false;

        //2010.11.19 채크된 폴더명만 가져 오는 변수
        string tempstrFolder=hfFolder.Value;

        string strFolder = "";
        string strPath = "";
        string strGroupName = "";
        string strDeleteFolder = "";
        string strDeleteFolderName = "";
        int iPos = 0;

        
        //폴더 구분이 ? 로 되어 있음
        string[] tempstrFolder2 = null;
        tempstrFolder2 = tempstrFolder.Split('?');

        //폴더 갯수만큼 삭제 루틴
        for (int i = 0; i < tempstrFolder2.Length; i++)
        {
            strFolder = tempstrFolder2[i];

            if (strFolder.Trim() == "")
            {
                JS.MessageBox("사용자 폴더는 삭제할 수 없습니다.");
                JS.HistoryBack();
                return;
            }

            if (strFolder.StartsWith("G:"))
            {
                bGroup = true;
                // 그룹명 잘라내기
                strFolder = strFolder.Substring(2);

                iPos = strFolder.IndexOf("|");

                if (iPos > -1)
                {
                    strGroupName = strFolder.Substring(0, iPos);
                    strFolder = strFolder.Substring(iPos + 1);
                }
                else
                {
                    iPos = strFolder.IndexOf(" ");
                    strGroupName = strFolder.Substring(0, iPos);
                    strFolder = strFolder.Substring(iPos + 1);
                }

                Group _group = new Group();
                _group.ConnectionString = strCon;

                try
                {
                    result = _group.LoadGroupInfo(strDomain, strGroupName);
                }
                catch (Exception err)
                {
                    JS.MessageBox(err.Message);
                    JS.HistoryBack();
                    return;
                }

                if (!result)
                {
                    JS.MessageBox(_group.ErrorMessage);
                    JS.HistoryBack();
                    return;
                }

                strPath = _group.GroupPath;

                if (strFolder.Trim() == "")
                {
                    JS.MessageBox(strGroupName + " 그룹 폴더는 관리자만 삭제할 수 있습니다.");
                    JS.HistoryBack();
                    return;
                }
            }
            else
                strPath = UI.WebhardPath;

            strFolder = strFolder.Replace("|", "\\");
            iPos = strFolder.LastIndexOf("\\");

            if (iPos > 0)
                strDeleteFolder = strFolder.Substring(iPos + 1);
            else
                strDeleteFolder = strFolder;

            if (strPath.EndsWith("\\"))
                strPath = strPath.Substring(0, strPath.Length - 1);

            if (!strFolder.StartsWith("\\"))
                strFolder = "\\" + strFolder;

            strPath += strFolder;

            // 폴더 삭제
            if (strDeleteFolder.Trim() != "")
            {
                if (!Directory.Exists(strPath))
                {
                    JS.MessageBox(strDeleteFolder + " 폴더가 사용자 폴더에 존재하지 않습니다.");
                    JS.HistoryBack();
                    return;
                }
                else
                    Directory.Delete(strPath, true);

                if (strFolder.StartsWith("\\"))
                    strFolder = strFolder.Substring(1);

                iPos = strFolder.LastIndexOf("\\");

                if (iPos > 0)
                    strFolder = strFolder.Substring(0, (strFolder.Length - strDeleteFolder.Length) - 1);
                else
                    strFolder = "";

                if (bGroup)
                    strDeleteFolderName = strGroupName + " 그룹 " + strFolder.Replace("\\", ">") + "폴더 내 " + strDeleteFolder;
                else
                    strDeleteFolderName = strDeleteFolder;

                strFolder = strFolder.Replace("\\", "|");
            }

            if (bGroup)
            {
                //2016.04.14 그룹 폴더 삭제시 상위 폴더가 없을 경우에도 상위 폴더가 있는 것으로 인식하는 문제 수정
                if (strFolder != "")
                    strFolder = "G:" + strGroupName + "|" + strFolder;
                else
                    strFolder = "G:" + strGroupName;
            }
            JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
        }
    }
    #endregion

    #region 파일 삭제 버튼
    /// <summary>
    /// 선택된 파일을 삭제한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnDeleteFile_Click(Object sender, EventArgs e)
    {
       
        string strFolders = hfFolder.Value;
        string strFiles = hfFiles.Value;

        string[] strFile;
        string[] strFolder;

        if (strFiles.Trim() == "")
        {
            JS.MessageBox("삭제할 파일이 선택되지 않았습니다.");
            JS.HistoryBack();
            return;
        }

        if (strFiles.EndsWith("|"))
            strFiles = strFiles.Substring(0, strFiles.Length - 1);

        //10.11.22
        //폴더 구분할때 , 로 구분하는데. 왜 그런지 모르겠음. 받아 오는 폴더는 1개인데. 일딴 주석처리함. 실제 폴더명이 , 일때 문제가 있음.
        
        //if (strFolders.EndsWith(","))
        //    strFolders = strFolders.Substring(0, strFolders.Length - 1);

        strFile = strFiles.Split('|');
        //strFolder = strFolders.Split(',');

        for (int i = 0; i < strFile.Length; i++)
        {
            //if (strFolder.Length == 1)
            //    FIleDelete(strFolders, strFile[i]);
            //else
            //    FIleDelete(strFolder[i], strFile[i]);

            FIleDelete(strFolders, strFile[i]);
        }

        JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolders.Replace("\\", "|")), "");

        //if (strFolder.Length == 1)
        //    JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolders.Replace("\\", "|")), "");
        //else
        //{
        //    //FileSearch(strSchValue);
        //    return;
        //}
    }

    
    #endregion

    #region 파일검색
    /// <summary>
    /// 파일명 또는 파일내 단어를 검색한다.
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void btnSearchFile_Click(Object sender, EventArgs e)
    {
        strSchValue = tbSearchFile.Text;
        bSearch = true;
        FileSearch(strSchValue);
    }
    #endregion

    #region 파일 삭제
    private void FIleDelete(string strFolder, string strFile)
    {
        bool result = false;
        string strPath = "";
        string strGroupName = "";

        strFolder = strFolder.Replace("|", "\\");

        if (strFolder.StartsWith("G:"))
        {
            strGroupName = strFolder.Substring(2);

            int iPos = strGroupName.IndexOf("\\");

            if (iPos > -1)
                strGroupName = strGroupName.Substring(0, iPos);

            // 그룹 정보를 불러와 그룹 전체 경로를 가져온다.
            Group _group = new Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroupName);
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }

            if (!result)
            {
                JS.MessageBox(_group.ErrorMessage);
                JS.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;
            strFolder = strFolder.Substring(strGroupName.Length + 2);

            if (_group.OwnerId != strMemberId)
            {
                // 그룹에 등록되어 있는 회원인지 확인하고
                // 다운 받을수 있는 권한이 있는지 확인한다.
                GroupMember _gm = new GroupMember();

                _gm.ConnectionString = strCon;

                try
                {
                    result = _gm.CheckGroupMember(strDomain, strGroupName, strMemberId);
                }
                catch (Exception err)
                {
                    JS.MessageBox(err.Message);
                    JS.HistoryBack();
                    return;
                }

                if (!result)
                {
                    JS.MessageBox(_gm.ErrorMessage);
                    JS.HistoryBack();
                    return;
                }

                if (_gm.IsDeleteLimit != "Y")
                {
                    JS.MessageBox(strMemberId + " 회원님은 선택한 파일을 삭제할 수 없습니다.");
                    JS.HistoryBack();
                    return;
                }
            }
        }
        else
            strPath = UI.WebhardPath;

        if (strFolder.Trim() != "")
        {
            if (!strPath.EndsWith("\\") && !strFolder.StartsWith("\\"))
                strPath += "\\" + strFolder;
            else
                strPath += strFolder;
        }

        if (strFile.Trim() != "")
        {
            strFile = strFile.Replace("＇", "'");

            if (File.Exists(strPath + "\\" + strFile))
                File.Delete(strPath + "\\" + strFile);
        }
    }
    #endregion

    #region 검색
    /// <summary>
    /// 웹하드에 있는 파일을 검색한다.
    /// </summary>
    /// <param name="strSchValue"></param>
    private void FileSearch(string strSchValue)
    {
        bool result = false;
        string strQuery = "";
        string strWhere = "";
        DataSet ds = new DataSet();
        DataTable dt = new DataTable();

        if (strSchValue.Trim() == "")
        {
            JS.MessageBox("검색어를 입력해 주세요.");
            JS.HistoryBack();
            return;
        }
        // 2017.09.06 Windows 2012 이상일 경우 Indexing Server Service가 아닌 Windows Search Service를 이용해야해서 추가함.
        if (OsMajor >= 6 && OsMinor >= 1)
        {
            strWhere = " Where SCOPE = 'file://" + UI.WebhardPath + "' And (FREETEXT (Contents, '" + strSchValue + "') or FREETEXT(System.FileName, '" + strSchValue + "') or System.FileName like '%" + strSchValue + "%' )";

            strQuery = "Select System.ItemPathDisplay, System.FileName, System.Size, System.DateModified From SystemIndex " +
            strWhere + " Order by System.FileName";

            OleDbConnection Con = new OleDbConnection("Provider=Search.CollatorDSO;Extended Properties='Application=Windows'");

            try
            {
                Con.Open();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }

            try
            {

                Webhard_Passkorea _wp = new Webhard_Passkorea();
                int iRltCnt = 0;
                OleDbCommand Cmd = new OleDbCommand(strQuery, Con);
                OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "FIND_FILES");
                dt = ds.Tables["FIND_FILES"];

                iRltCnt = dt.Rows.Count;

                if (iRltCnt > 0)
                {
                    string[,] strSearchFiles = new string[iRltCnt, 4];

                    for (int i = 0; i < iRltCnt; i++)
                    {
                        strSearchFiles[i, 0] = dt.Rows[i]["System.ItemPathDisplay"].ToString();
                        strSearchFiles[i, 1] = dt.Rows[i]["System.Filename"].ToString();
                        strSearchFiles[i, 2] = dt.Rows[i]["System.Size"].ToString();
                        strSearchFiles[i, 3] = dt.Rows[i]["System.DateModified"].ToString();

                        DateTime tdt = Convert.ToDateTime(strSearchFiles[i, 3]);
                        strSearchFiles[i, 3] = tdt.AddHours(9).ToString();

                        int iLen = UI.WebhardPath.Length;

                        int iPos = strSearchFiles[i, 0].LastIndexOf("\\");

                        if (iPos > -1)
                            strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(0, iPos);

                        if (strSearchFiles[i, 0].Substring(0, iLen).ToLower() == UI.WebhardPath.ToLower())
                            strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(iLen);

                        if (strSearchFiles[i, 0].StartsWith("\\"))
                            strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(1);

                        strSearchFiles[i, 0] = strSearchFiles[i, 0].Replace("\\", "|");
                    }

                    dt.Rows.Clear();
                    dt.Columns.Clear();

                    dt.Columns.Add("FILE_TYPE", Type.GetType("System.String"));
                    dt.Columns.Add("FOLDER", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_NAME", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_PATH", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_SIZE", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_REAL_SIZE", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_DATE", Type.GetType("System.String"));

                    for (int i = 0; i < iRltCnt; i++)
                    {
                        string strFilePath = "";

                        //2017.09.07 폴더일 경우 제외하기 위해 사이즈가 없을 경우를 추가.
                        if (strSearchFiles[i, 1].Trim() == "" || strSearchFiles[i, 2].Trim() == "")
                            continue;

                        if (strSearchFiles[i, 0].Trim() != "")
                            strFilePath = strSearchFiles[i, 0].Replace("|", "> ") + "> " + strSearchFiles[i, 1];
                        else
                            strFilePath = strSearchFiles[i, 1];

                        DataRow dr = dt.NewRow();
                        dr["FILE_TYPE"] = FileExtType(strSearchFiles[i, 1]);
                        dr["FOLDER"] = strSearchFiles[i, 0];
                        dr["FILE_NAME"] = strSearchFiles[i, 1].Replace("'", "＇");
                        dr["FILE_PATH"] = "<a href=\"Download.aspx?dir=" + Server.UrlEncode(strSearchFiles[i, 0]) + "&file=" + Server.UrlEncode(strSearchFiles[i, 1]) + "\">" + strFilePath + "</a>";
                        dr["FILE_SIZE"] = _wp.CalcSize(long.Parse(strSearchFiles[i, 2])).ToString();
                        dr["FILE_REAL_SIZE"] = strSearchFiles[i, 2];
                        dr["FILE_DATE"] = strSearchFiles[i, 3];
                        dt.Rows.Add(dr);
                    }

                    btnDeleteFolder.Visible = false;

                }

                rptSearchFiles.DataSource = dt;
                rptSearchFiles.DataBind();
                return;
            }
            catch (Exception err)
            {
                Con.Close();
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }
        }
        else
        {
            strWhere = " Where FREETEXT (Contents, '" + strSchValue + "') or FREETEXT(Filename, '" + strSchValue + "') or filename like '%" + strSchValue + "%' ";

            strQuery = "Select Directory, Filename, Size, Write From N_Webhard..Scope('\"" + UI.WebhardPath + "\"') " +
                strWhere + " Order by FileName";


            OleDbConnection Con = new OleDbConnection("Provider=MSIDXS; Data Source=Nmail_Data;");

            try
            {
                Con.Open();
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }

            try
            {

                Webhard_Passkorea _wp = new Webhard_Passkorea();
                int iRltCnt = 0;
                OleDbCommand Cmd = new OleDbCommand(strQuery, Con);
                OleDbDataAdapter Adap = new OleDbDataAdapter(Cmd);
                Adap.Fill(ds, "FIND_FILES");
                dt = ds.Tables["FIND_FILES"];

                iRltCnt = dt.Rows.Count;

                if (iRltCnt > 0)
                {
                    string[,] strSearchFiles = new string[iRltCnt, 4];

                    for (int i = 0; i < iRltCnt; i++)
                    {
                        strSearchFiles[i, 0] = dt.Rows[i]["Directory"].ToString();
                        strSearchFiles[i, 1] = dt.Rows[i]["Filename"].ToString();
                        strSearchFiles[i, 2] = dt.Rows[i]["Size"].ToString();
                        strSearchFiles[i, 3] = dt.Rows[i]["Write"].ToString();

                        int iLen = UI.WebhardPath.Length;

                        if (strSearchFiles[i, 0].Substring(0, iLen).ToLower() == UI.WebhardPath.ToLower())
                            strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(iLen);

                        if (strSearchFiles[i, 0].StartsWith("\\"))
                            strSearchFiles[i, 0] = strSearchFiles[i, 0].Substring(1);

                        strSearchFiles[i, 0] = strSearchFiles[i, 0].Replace("\\", "|");
                    }

                    dt.Rows.Clear();
                    dt.Columns.Clear();

                    dt.Columns.Add("FILE_TYPE", Type.GetType("System.String"));
                    dt.Columns.Add("FOLDER", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_NAME", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_PATH", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_SIZE", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_REAL_SIZE", Type.GetType("System.String"));
                    dt.Columns.Add("FILE_DATE", Type.GetType("System.String"));

                    for (int i = 0; i < iRltCnt; i++)
                    {
                        string strFilePath = "";

                        if (strSearchFiles[i, 1].Trim() == "")
                            continue;

                        if (strSearchFiles[i, 0].Trim() != "")
                            strFilePath = strSearchFiles[i, 0].Replace("|", "> ") + "> " + strSearchFiles[i, 1];
                        else
                            strFilePath = strSearchFiles[i, 1];

                        DataRow dr = dt.NewRow();
                        dr["FILE_TYPE"] = FileExtType(strSearchFiles[i, 1]);
                        dr["FOLDER"] = strSearchFiles[i, 0];
                        dr["FILE_NAME"] = strSearchFiles[i, 1].Replace("'", "＇");
                        dr["FILE_PATH"] = "<a href=\"Download.aspx?dir=" + Server.UrlEncode(strSearchFiles[i, 0]) + "&file=" + Server.UrlEncode(strSearchFiles[i, 1]) + "\">" + strFilePath + "</a>";
                        dr["FILE_SIZE"] = _wp.CalcSize(long.Parse(strSearchFiles[i, 2])).ToString();
                        dr["FILE_REAL_SIZE"] = strSearchFiles[i, 2];
                        dr["FILE_DATE"] = strSearchFiles[i, 3];
                        dt.Rows.Add(dr);
                    }

                    btnDeleteFolder.Visible = false;

                }

                rptSearchFiles.DataSource = dt;
                rptSearchFiles.DataBind();
                return;
            }
            catch (Exception err)
            {
                Con.Close();
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }
        }
    }
    #endregion

    private string FileExtType(string filename)
    {
        int iPos = 0;
        string fileExt = "";

        if (filename != "")
        {
            iPos = filename.LastIndexOf(".");

            if (iPos > 0)
            {
                fileExt = filename.Substring(iPos + 1);
                fileExt = fileExt.ToUpper() + " 파일";
            }
            else
                fileExt = "파일";
        }

        return fileExt;
    }
    //2016.04.12 필터링을 하기 위해 파일 확장자 가져오기 추가
    private string FileExt(string filename)
    {
        int iPos = 0;
        string fileExt = "";

        if (filename != "")
        {
            iPos = filename.LastIndexOf(".");

            if (iPos > 0)
            {
                fileExt = filename.Substring(iPos + 1).ToLower();
            }
            else
                fileExt = "";
        }
        return fileExt;
    }


    public void AttachFile()
    {

        bool result = false;
        bool bGroup = false;

        string tempstrFolder = hfFolder.Value;

        string strFolder = "";
        string strPath = "";
        string strGroupName = "";
        int iPos = 0;

        string strMessage = "";
        string strUploadMessage = "";
        string strFilterMessage = "";
        string strOverlapMessage = "";

        // 2016.04.12 필터링을 하기 위해 추가
        UploadFilter _filter = new UploadFilter();

        _filter.ConnectionString = strCon;

        try
        {
            result = _filter.LoadUploadFilter(strDomain, strAdminId);
        }
        catch (Exception e)
        {
            JS.MessageBox(e.Message);
            JS.HistoryBack();
            return;
        }

        if (!result)
        {
            JS.MessageBox(_filter.ErrorMessage);
            JS.HistoryBack();
            return;
        }

        strExtFilter = _filter.FileExtensions;


        //폴더 이름 가져오는 루틴
        strFolder = tempstrFolder;

        if (strFolder.StartsWith("G:"))
        {
            bGroup = true;
            // 그룹명 잘라내기
            strFolder = strFolder.Substring(2);

            iPos = strFolder.IndexOf("|");

            if (iPos > -1)
            {
                strGroupName = strFolder.Substring(0, iPos);
                strFolder = strFolder.Substring(iPos + 1);
            }
            else
            {
                iPos = strFolder.IndexOf(" ");
                if (iPos > -1)
                {
                    strGroupName = strFolder.Substring(0, iPos);
                    strFolder = strFolder.Substring(iPos + 1);
                }
                else
                {
                    strGroupName = strFolder.ToString();
                    strFolder = "";
                }
            }

            Group _group = new Group();
            _group.ConnectionString = strCon;

            try
            {
                result = _group.LoadGroupInfo(strDomain, strGroupName);
            }
            catch (Exception err)
            {
                JS.MessageBox(err.Message);
                JS.HistoryBack();
                return;
            }

            if (!result)
            {
                JS.MessageBox(_group.ErrorMessage);
                JS.HistoryBack();
                return;
            }

            strPath = _group.GroupPath;

        }
        else
            strPath = UI.WebhardPath;

        strFolder = strFolder.Replace("|", "\\");
        iPos = strFolder.LastIndexOf("\\");

        if (strPath.EndsWith("\\"))
            strPath = strPath.Substring(0, strPath.Length - 1);

        if (strFolder != "")
        {
            if (!strFolder.StartsWith("\\"))
                strFolder = "\\" + strFolder;


            strPath += strFolder;

            strFolder = strFolder.Replace("\\", "|");

        }

        if (bGroup)
        {
            if (strFolder != "")
                strFolder = "G:" + strGroupName + strFolder;
            else
                strFolder = "G:" + strGroupName;
        }

        try
        {
            //string strAttachFile = "";

            // 업로드될 경로가 존재하지 않으면 경로를 생성한다.
            if (!Directory.Exists(strPath))
                Directory.CreateDirectory(strPath);

            // 첨부파일 객체가 null이 아니면 파일을 업로드 한다.
            if (txtAttachFile.PostedFile != null)
            {
                // 클라이언트에 있는 첨부파일 전체 경로를 가져온다.
                //strAttachFile = txtAttachFile.Value;
                HttpFileCollection strAttachFile = Request.Files;

                for (int i = 0; i < strAttachFile.Count; i++)
                {
                    HttpPostedFile hpAttachFile = strAttachFile[i];

                    if (hpAttachFile.ContentLength > 0)
                    {
                        // 값이 있으면 서버에 업로드한다.
                        //if (strAttachFile[i].ToString() != "")
                        //{
                            // 첨부파일명
                            //strAttachFile = Path.GetFileName(strAttachFile);

                            if (!File.Exists(strPath + "\\" + Path.GetFileName(hpAttachFile.FileName)))
                            {
                                // 2016.04.12 필터링을 하기 위해 파일 확장자 가져오기 추가
                                string[] strExtFilts = null;
                                bool bFile = false;
                                strExtFilts = strExtFilter.Split(';');
                                
                                for (int j = 0; j < strExtFilts.Length; j++)
                                {
                                    string fileExt = FileExt(Path.GetFileName(hpAttachFile.FileName));

                                    if (fileExt.ToLower() == strExtFilts[j].ToLower())
                                    {
                                        bFile = true;

                                        //JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
                                        //return;
                                    }
                                }

                                if (!bFile)
                                {
                                    // 첨부파일을 서버에 업로드
                                    hpAttachFile.SaveAs(strPath + "\\" + Path.GetFileName(hpAttachFile.FileName));
                                    //JS.MessageBox(Path.GetFileName(hpAttachFile.FileName) + " 파일이 업로드 되었습니다.");
                                    if (strUploadMessage == "")
                                        strUploadMessage += "[업로드 파일] \r\n파일명 : ";

                                    strUploadMessage += Path.GetFileName(hpAttachFile.FileName) + "\r\n";
                                    //JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
                                    //return;
                                }
                            }
                            else
                            {
                                //JS.MessageBox("같은 파일명이 있습니다.\r\n파일명 : " + Path.GetFileName(hpAttachFile.FileName));
                                if (strOverlapMessage == "")
                                    strOverlapMessage += "[중복된 파일] \r\n파일명 : ";

                                strOverlapMessage += Path.GetFileName(hpAttachFile.FileName) + "\r\n";
                                //JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
                                //return;
                            }
                        //}
                    }

                }

                strMessage = strOverlapMessage + strUploadMessage;

                if (strMessage != "")
                {
                    if (strMessage.EndsWith("\r\n"))
                        strMessage = strMessage.Substring(0, strMessage.Length - 2);

                    JS.MessageBox(strMessage);

                    JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
                    return;
                }
                else
                    return;
            }
        }
        catch (Exception ex)
        {
            JS.MessageBox(ex.Message + "파일 업로드가 실패 했습니다");
            JS.MovePage("Webhard.aspx?dir=" + Server.UrlEncode(strFolder), "");
            return;
        }
    }


}
